//+------------------------------------------------------------------+
//|                                                      BB_Zeul.mq4 |
//|                                        Copyright 2015, galladion |
//|                                         https://vk.com/id1398982 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, galladion"
#property link      "https://vk.com/id1398982"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 12
#property indicator_plots   12
//--- plot bb1_up
#property indicator_label1  "bb1_up"
#property indicator_type1   DRAW_LINE
//#property indicator_color1  clrRed
//#property indicator_style1  STYLE_SOLID
//#property indicator_width1  1
//--- plot bb1_down
#property indicator_label2  "bb1_down"
#property indicator_type2   DRAW_LINE
//#property indicator_color2  clrRed
//#property indicator_style2  STYLE_SOLID
//#property indicator_width2  1
//--- plot bb2_up
#property indicator_label3  "bb2_up"
#property indicator_type3   DRAW_LINE
//#property indicator_color3  clrGreen
//#property indicator_style3  STYLE_SOLID
//#property indicator_width3  1
//--- plot bb2_down
#property indicator_label4  "bb2_down"
#property indicator_type4   DRAW_LINE
//#property indicator_color4  clrGreen
//#property indicator_style4  STYLE_SOLID
//#property indicator_width4  1
//--- plot bb3_up
#property indicator_label5  "bb3_up"
#property indicator_type5   DRAW_LINE
//#property indicator_color5  clrYellow
//#property indicator_style5  STYLE_SOLID
//#property indicator_width5  1
//--- plot bb3_down
#property indicator_label6  "bb3_down"
#property indicator_type6   DRAW_LINE
//#property indicator_color6  clrYellow
//#property indicator_style6  STYLE_SOLID
//#property indicator_width6  1
//--- plot bb4_up
#property indicator_label7  "bb4_up"
#property indicator_type7   DRAW_LINE
//#property indicator_color7  clrBlue
//#property indicator_style7  STYLE_SOLID
//#property indicator_width7  1
//--- plot bb4_down
#property indicator_label8  "bb4_down"
#property indicator_type8   DRAW_LINE
//#property indicator_color8  clrBlue
//#property indicator_style8  STYLE_SOLID
//#property indicator_width8  1
//--- plot bb5_up
#property indicator_label9  "bb5_up"
#property indicator_type9   DRAW_LINE
//#property indicator_color9  clrOrange
//#property indicator_style9  STYLE_SOLID
//#property indicator_width9  1
//--- plot bb5_down
#property indicator_label10  "bb5_down"
#property indicator_type10   DRAW_LINE
//#property indicator_color10  clrOrange
//#property indicator_style10  STYLE_SOLID
//#property indicator_width10  1
//--- plot bb6_up
#property indicator_label11  "bb6_up"
#property indicator_type11   DRAW_LINE
//#property indicator_color11  clrWhite
//#property indicator_style11  STYLE_SOLID
//#property indicator_width11  1
//--- plot bb6_down
#property indicator_label12  "bb6_down"
#property indicator_type12   DRAW_LINE
//#property indicator_color12  clrWhite
//#property indicator_style12  STYLE_SOLID
//#property indicator_width12  1
//--- indicator buffers
double         bb1_upBuffer[];
double         bb1_downBuffer[];
double         bb2_upBuffer[];
double         bb2_downBuffer[];
double         bb3_upBuffer[];
double         bb3_downBuffer[];
double         bb4_upBuffer[];
double         bb4_downBuffer[];
double         bb5_upBuffer[];
double         bb5_downBuffer[];
double         bb6_upBuffer[];
double         bb6_downBuffer[];
//---
enum t_frame
  {
   frame_0 = 0,//0
   frame_1 = 1,//M1
   frame_2 = 5,//M5
   frame_3 = 15,//M15
   frame_4 = 30,//M30
   frame_5 = 60,//H1
   frame_6= 240,//H4
   frame_7=1440,//D1
   frame_8 = 10080,//W1
   frame_9 = 43200,//MN
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum line_w
  {
   l1 = 1,//1
   l2 = 2,//2
   l3 = 3,//3
   l4 = 4,//4
   l5=5//5
  };
extern   string               Option1="Options:";//-------------Bollinger Bands 1-------------
input    t_frame              bb1_tf_chart;//Chart Timeframe
input    t_frame              bb1_tf;//BB1 Timeframe
input    int                  bb1_Period=20;//Period
input    double               bb1_deviation=2.0;//Deviation
input    color                bb1_color= clrRed;//Line Color
input    line_w               bb1_line_w=l1;//Line Width
input    ENUM_LINE_STYLE      bb1_line_style=0;//Line Style
extern   string               Option2="--------------------BB1 Alerts--------------------";//---------------------------------------
input    bool                 bb1_up=true;//Break Up Alerts
input    bool                 bb1_doun= true;//Break Down Alerts
input    bool                 bb1_box = true;//Box Alerts
input    bool                 bb1_text_whrite=true;//Default Text
                                                   //input    string               bb1_text_str="AUD/JPY Broke (M) BB UP";//Default Text
//input    bool                 bb1_custom_box=true;//Custom Box Text
input    string               bb1_custom_text="ALERT TEXT HERE";//Custom Box Alert Text
input    bool                 bb1_mail = false;//EMAIL Alerts
input    bool                 bb1_push = false;//PUSH Alerts
input    bool                 bb1_audio = true;//Audio Alerts
input    string               bb1_audio_up= "";//Audio Alert Up
input    string               bb1_audio_down="";//Audio Alert Down
input    bool                 bb1_pause=false;//Pause Between Alerts
input    int                  bb1_sec=0;//Time to Pause Between Alerts: A Time Value in Seconds.
//----------------------------
extern   string               Option3="Options:";//-------------Bollinger Bands 2-------------
input    t_frame              bb2_tf_chart;//Chart Timeframe
input    t_frame              bb2_tf;//BB2 Timeframe
input    int                  bb2_Period=20;//Period
input    double               bb2_deviation=2.0;//Deviation
input    color                bb2_color=clrGreen;//Line Color
input    line_w               bb2_line_w=l1;//Line Width
input    ENUM_LINE_STYLE      bb2_line_style=0;//Line Style
extern   string               Option4="--------------------BB2 Alerts--------------------";//---------------------------------------
input    bool                 bb2_up=true;//Break Up Alerts
input    bool                 bb2_doun= true;//Break Down Alerts
input    bool                 bb2_box = true;//Box Alerts
input    bool                 bb2_text_whrite=true;//Default Text
                                                   //input    string               bb2_text_str="AUD/JPY Broke (M) BB UP";//Default Text
//input    bool                 bb2_custom_box=true;//Custom Box Text
input    string               bb2_custom_text="ALERT TEXT HERE";//Custom Box Alert Text
input    bool                 bb2_mail = false;//EMAIL Alerts
input    bool                 bb2_push = false;//PUSH Alerts
input    bool                 bb2_audio = true;//Audio Alerts
input    string               bb2_audio_up= "";//Audio Alert Up
input    string               bb2_audio_down="";//Audio Alert Down
input    bool                 bb2_pause=false;//Pause Between Alerts
input    int                  bb2_sec=0;//Time to Pause Between Alerts: A Time Value in Seconds.
//----------------------------
extern   string               Option5="Options:";//-------------Bollinger Bands 3-------------
input    t_frame              bb3_tf_chart;//Chart Timeframe
input    t_frame              bb3_tf;//BB3 Timeframe
input    int                  bb3_Period=20;//Period
input    double               bb3_deviation=2.0;//Deviation
input    color                bb3_color=clrBlue;//Line Color
input    line_w               bb3_line_w=l1;//Line Width
input    ENUM_LINE_STYLE      bb3_line_style=0;//Line Style
extern   string               Option6="--------------------BB3 Alerts--------------------";//---------------------------------------
input    bool                 bb3_up=true;//Break Up Alerts
input    bool                 bb3_doun= true;//Break Down Alerts
input    bool                 bb3_box = true;//Box Alerts
input    bool                 bb3_text_whrite=true;//Default Text
                                                   //input    string               bb3_text_str="AUD/JPY Broke (M) BB UP";//Default Text
//input    bool                 bb3_custom_box=true;//Custom Box Text
input    string               bb3_custom_text="ALERT TEXT HERE";//Custom Box Alert Text
input    bool                 bb3_mail = false;//EMAIL Alerts
input    bool                 bb3_push = false;//PUSH Alerts
input    bool                 bb3_audio = true;//Audio Alerts
input    string               bb3_audio_up= "";//Audio Alert Up
input    string               bb3_audio_down="";//Audio Alert Down
input    bool                 bb3_pause=false;//Pause Between Alerts
input    int                  bb3_sec=0;//Time to Pause Between Alerts: A Time Value in Seconds.
//----------------------------
extern   string               Option7="Options:";//-------------Bollinger Bands 4-------------
input    t_frame              bb4_tf_chart;//Chart Timeframe
input    t_frame              bb4_tf;//BB4 Timeframe
input    int                  bb4_Period=20;//Period
input    double               bb4_deviation=2.0;//Deviation
input    color                bb4_color=clrYellow;//Line Color
input    line_w               bb4_line_w=l1;//Line Width
input    ENUM_LINE_STYLE      bb4_line_style=0;//Line Style
extern   string               Option8="--------------------BB4 Alerts--------------------";//---------------------------------------
input    bool                 bb4_up=true;//Break Up Alerts
input    bool                 bb4_doun= true;//Break Down Alerts
input    bool                 bb4_box = true;//Box Alerts
input    bool                 bb4_text_whrite=true;//Default Text
                                                   //input    string               bb4_text_str="AUD/JPY Broke (M) BB UP";//Default Text
//input    bool                 bb4_custom_box=true;//Custom Box Text
input    string               bb4_custom_text="ALERT TEXT HERE";//Custom Box Alert Text
input    bool                 bb4_mail = false;//EMAIL Alerts
input    bool                 bb4_push = false;//PUSH Alerts
input    bool                 bb4_audio = true;//Audio Alerts
input    string               bb4_audio_up= "";//Audio Alert Up
input    string               bb4_audio_down="";//Audio Alert Down
input    bool                 bb4_pause=false;//Pause Between Alerts
input    int                  bb4_sec=0;//Time to Pause Between Alerts: A Time Value in Seconds.
//----------------------------
extern   string               Option9="Options:";//-------------Bollinger Bands 5-------------
input    t_frame              bb5_tf_chart;//Chart Timeframe
input    t_frame              bb5_tf;//BB5 Timeframe
input    int                  bb5_Period=20;//Period
input    double               bb5_deviation=2.0;//Deviation
input    color                bb5_color=clrWhite;//Line Color
input    line_w               bb5_line_w=l1;//Line Width
input    ENUM_LINE_STYLE      bb5_line_style=0;//Line Style
extern   string               Option10="--------------------BB5 Alerts--------------------";//---------------------------------------
input    bool                 bb5_up=true;//Break Up Alerts
input    bool                 bb5_doun= true;//Break Down Alerts
input    bool                 bb5_box = true;//Box Alerts
input    bool                 bb5_text_whrite=true;//Default Text
                                                   //input    string               bb5_text_str="AUD/JPY Broke (M) BB UP";//Default Text
//input    bool                 bb5_custom_box=true;//Custom Box Text
input    string               bb5_custom_text="ALERT TEXT HERE";//Custom Box Alert Text
input    bool                 bb5_mail = false;//EMAIL Alerts
input    bool                 bb5_push = false;//PUSH Alerts
input    bool                 bb5_audio = true;//Audio Alerts
input    string               bb5_audio_up= "";//Audio Alert Up
input    string               bb5_audio_down="";//Audio Alert Down
input    bool                 bb5_pause=false;//Pause Between Alerts
input    int                  bb5_sec=0;//Time to Pause Between Alerts: A Time Value in Seconds.
//----------------------------
extern   string               Option11="Options:";//-------------Bollinger Bands 6-------------
input    t_frame              bb6_tf_chart;//Chart Timeframe
input    t_frame              bb6_tf;//BB6 Timeframe
input    int                  bb6_Period=20;//Period
input    double               bb6_deviation=2.0;//Deviation
input    color                bb6_color=clrMagenta;//Line Color
input    line_w               bb6_line_w=l1;//Line Width
input    ENUM_LINE_STYLE      bb6_line_style=0;//Line Style
extern   string               Option12="--------------------BB6 Alerts--------------------";//---------------------------------------
input    bool                 bb6_up=true;//Break Up Alerts
input    bool                 bb6_doun= true;//Break Down Alerts
input    bool                 bb6_box = true;//Box Alerts
input    bool                 bb6_text_whrite=true;//Default Text
                                                   //input    string               bb6_text_str="AUD/JPY Broke (M) BB UP";//Default Text
//input    bool                 bb6_custom_box=true;//Custom Box Text
input    string               bb6_custom_text="ALERT TEXT HERE";//Custom Box Alert Text
input    bool                 bb6_mail = false;//EMAIL Alerts
input    bool                 bb6_push = false;//PUSH Alerts
input    bool                 bb6_audio = true;//Audio Alerts
input    string               bb6_audio_up= "";//Audio Alert Up
input    string               bb6_audio_down="";//Audio Alert Down
input    bool                 bb6_pause=false;//Pause Between Alerts
input    int                  bb6_sec=0;//Time to Pause Between Alerts: A Time Value in Seconds.
double hist_cl[];
string Global_DT="time";
string Global_count="count";
datetime dt=TimeLocal(),dt_push,dt_draw,time_sec;
int count=0;
string str;
int tmp;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   IndicatorBuffers(13);
   SetIndexBuffer(0,bb1_upBuffer);
   SetIndexLabel(0,"BB1 UP("+(string)bb1_tf+","+(string)bb1_Period+","+(string)bb1_deviation+")");
   SetIndexStyle(0,DRAW_LINE,bb1_line_style,bb1_line_w,bb1_color);
   SetIndexBuffer(1,bb1_downBuffer);
   SetIndexLabel(1,"BB1 DOWN("+(string)bb1_tf+","+(string)bb1_Period+","+(string)bb1_deviation+")");
   SetIndexStyle(1,DRAW_LINE,bb1_line_style,bb1_line_w,bb1_color);
   SetIndexBuffer(2,bb2_upBuffer);
   SetIndexLabel(2,"BB2 UP("+(string)bb2_tf+","+(string)bb2_Period+","+(string)bb2_deviation+")");
   SetIndexStyle(2,DRAW_LINE,bb2_line_style,bb2_line_w,bb2_color);
   SetIndexBuffer(3,bb2_downBuffer);
   SetIndexLabel(3,"BB2 DOWN("+(string)bb2_tf+","+(string)bb2_Period+","+(string)bb2_deviation+")");
   SetIndexStyle(3,DRAW_LINE,bb2_line_style,bb2_line_w,bb2_color);
   SetIndexBuffer(4,bb3_upBuffer);
   SetIndexLabel(4,"BB3 UP("+(string)bb3_tf+","+(string)bb3_Period+","+(string)bb3_deviation+")");
   SetIndexStyle(4,DRAW_LINE,bb3_line_style,bb3_line_w,bb3_color);
   SetIndexBuffer(5,bb3_downBuffer);
   SetIndexLabel(5,"BB3 DOWN("+(string)bb3_tf+","+(string)bb3_Period+","+(string)bb3_deviation+")");
   SetIndexStyle(5,DRAW_LINE,bb3_line_style,bb3_line_w,bb3_color);
   SetIndexBuffer(6,bb4_upBuffer);
   SetIndexLabel(6,"BB4 UP("+(string)bb4_tf+","+(string)bb4_Period+","+(string)bb4_deviation+")");
   SetIndexStyle(6,DRAW_LINE,bb4_line_style,bb4_line_w,bb4_color);
   SetIndexBuffer(7,bb4_downBuffer);
   SetIndexLabel(7,"BB4 DOWN("+(string)bb4_tf+","+(string)bb4_Period+","+(string)bb4_deviation+")");
   SetIndexStyle(7,DRAW_LINE,bb4_line_style,bb4_line_w,bb4_color);
   SetIndexBuffer(8,bb5_upBuffer);
   SetIndexLabel(8,"BB5 UP("+(string)bb5_tf+","+(string)bb5_Period+","+(string)bb5_deviation+")");
   SetIndexStyle(8,DRAW_LINE,bb5_line_style,bb5_line_w,bb5_color);
   SetIndexBuffer(9,bb5_downBuffer);
   SetIndexLabel(9,"BB5 DOWN("+(string)bb5_tf+","+(string)bb5_Period+","+(string)bb5_deviation+")");
   SetIndexStyle(9,DRAW_LINE,bb5_line_style,bb5_line_w,bb5_color);
   SetIndexBuffer(10,bb6_upBuffer);
   SetIndexLabel(10,"BB6 UP("+(string)bb6_tf+","+(string)bb6_Period+","+(string)bb6_deviation+")");
   SetIndexStyle(10,DRAW_LINE,bb6_line_style,bb6_line_w,bb6_color);
   SetIndexBuffer(11,bb6_downBuffer);
   SetIndexLabel(11,"BB6 DOWN("+(string)bb6_tf+","+(string)bb6_Period+","+(string)bb6_deviation+")");
   SetIndexStyle(11,DRAW_LINE,bb6_line_style,bb6_line_w,bb6_color);
   SetIndexBuffer(12,hist_cl);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
//------------
   int i,limit;
//--- last counted bar will be recounted
   limit=rates_total-prev_calculated;
   tmp = limit;
   if(prev_calculated>0)
      limit++;
//--- 
   for(i=0; i<limit; i++)
     {
      if(bb1_tf_chart==Period())
        {
         if(bb1_tf==Period())
           {
            SetIndexDrawBegin(0,bb1_Period+1);SetIndexDrawBegin(1,bb1_Period+1);
            bb1_upBuffer[i]=iBands(Symbol(),0,bb1_Period,bb1_deviation,0,PRICE_CLOSE,MODE_UPPER,i);
            bb1_downBuffer[i]=iBands(Symbol(),0,bb1_Period,bb1_deviation,0,PRICE_CLOSE,MODE_LOWER,i);
           }
         else
           {
            SetIndexDrawBegin(0,bb1_Period+1);SetIndexDrawBegin(1,bb1_Period+1);
            bb1_upBuffer[i]=iBands(Symbol(),bb1_tf,bb1_Period,bb1_deviation,0,PRICE_CLOSE,MODE_UPPER,iBarShift(Symbol(),bb1_tf,time[i]));
            bb1_downBuffer[i]=iBands(Symbol(),bb1_tf,bb1_Period,bb1_deviation,0,PRICE_CLOSE,MODE_LOWER,iBarShift(Symbol(),bb1_tf,time[i]));
           }
         if(close[i]>bb1_upBuffer[i])alert(close[i],
            bb1_upBuffer[i],
            bb1_tf,
            bb1_up,
            bb1_doun,
            bb1_box,
            bb1_text_whrite,
            //            bb1_text_str,
            //            bb1_custom_box,
            bb1_custom_text,
            bb1_mail,
            bb1_push,
            bb1_audio,
            bb1_audio_up,
            bb1_audio_down,
            bb1_pause,
            bb1_sec
            );

         if(close[i]<bb1_downBuffer[i])alert(close[i],
            bb1_downBuffer[i],
            bb1_tf,
            bb1_up,
            bb1_doun,
            bb1_box,
            bb1_text_whrite,
            //            bb1_text_str,
            //            bb1_custom_box,
            bb1_custom_text,
            bb1_mail,
            bb1_push,
            bb1_audio,
            bb1_audio_up,
            bb1_audio_down,
            bb1_pause,
            bb1_sec
            );
        }
      if(bb2_tf_chart==Period())
        {
         if(bb2_tf==Period())
           {
            SetIndexDrawBegin(2,bb2_Period+1);SetIndexDrawBegin(3,bb2_Period+1);
            bb2_upBuffer[i]=iBands(Symbol(),0,bb2_Period,bb2_deviation,0,PRICE_CLOSE,MODE_UPPER,i);
            bb2_downBuffer[i]=iBands(Symbol(),0,bb2_Period,bb2_deviation,0,PRICE_CLOSE,MODE_LOWER,i);
           }
         else
           {
            SetIndexDrawBegin(2,bb2_Period+1);SetIndexDrawBegin(3,bb2_Period+1);
            bb2_upBuffer[i]=iBands(Symbol(),bb2_tf,bb1_Period,bb2_deviation,0,PRICE_CLOSE,MODE_UPPER,iBarShift(Symbol(),bb2_tf,time[i]));
            bb2_downBuffer[i]=iBands(Symbol(),bb2_tf,bb1_Period,bb2_deviation,0,PRICE_CLOSE,MODE_LOWER,iBarShift(Symbol(),bb2_tf,time[i]));
           }
         if(close[i]>bb2_upBuffer[i])alert(close[i],
            bb2_upBuffer[i],
            bb2_tf,
            bb2_up,
            bb2_doun,
            bb2_box,
            bb2_text_whrite,
            //            bb2_text_str,
            //            bb2_custom_box,
            bb2_custom_text,
            bb2_mail,
            bb2_push,
            bb2_audio,
            bb2_audio_up,
            bb2_audio_down,
            bb2_pause,
            bb2_sec
            );
         if(close[i]<bb2_downBuffer[i])alert(close[i],
            bb2_downBuffer[i],
            bb2_tf,
            bb2_up,
            bb2_doun,
            bb2_box,
            bb2_text_whrite,
            //            bb2_text_str,
            //            bb2_custom_box,
            bb2_custom_text,
            bb2_mail,
            bb2_push,
            bb2_audio,
            bb2_audio_up,
            bb2_audio_down,
            bb2_pause,
            bb2_sec
            );
        }
      if(bb3_tf_chart==Period())
        {
         if(bb3_tf==Period())
           {
            SetIndexDrawBegin(4,bb3_Period+1);SetIndexDrawBegin(5,bb3_Period+1);
            bb3_upBuffer[i]=iBands(Symbol(),0,bb3_Period,bb3_deviation,0,PRICE_CLOSE,MODE_UPPER,i);
            bb3_downBuffer[i]=iBands(Symbol(),0,bb3_Period,bb3_deviation,0,PRICE_CLOSE,MODE_LOWER,i);
           }
         else
           {
            SetIndexDrawBegin(4,bb3_Period+1);SetIndexDrawBegin(5,bb3_Period+1);
            bb3_upBuffer[i]=iBands(Symbol(),bb3_tf,bb1_Period,bb3_deviation,0,PRICE_CLOSE,MODE_UPPER,iBarShift(Symbol(),bb3_tf,time[i]));
            bb3_downBuffer[i]=iBands(Symbol(),bb3_tf,bb1_Period,bb3_deviation,0,PRICE_CLOSE,MODE_LOWER,iBarShift(Symbol(),bb3_tf,time[i]));
           }
         if(close[i]>bb3_upBuffer[i])alert(close[i],
            bb3_upBuffer[i],
            bb3_tf,
            bb3_up,
            bb3_doun,
            bb3_box,
            bb3_text_whrite,
            //            bb3_text_str,
            //            bb3_custom_box,
            bb3_custom_text,
            bb3_mail,
            bb3_push,
            bb3_audio,
            bb3_audio_up,
            bb3_audio_down,
            bb3_pause,
            bb3_sec
            );
         if(close[i]<bb3_downBuffer[i])alert(close[i],
            bb3_downBuffer[i],
            bb3_tf,
            bb3_up,
            bb3_doun,
            bb3_box,
            bb3_text_whrite,
            //            bb3_text_str,
            //            bb3_custom_box,
            bb3_custom_text,
            bb3_mail,
            bb3_push,
            bb3_audio,
            bb3_audio_up,
            bb3_audio_down,
            bb3_pause,
            bb3_sec
            );
        }
      if(bb4_tf_chart==Period())
        {
         if(bb4_tf==Period())
           {
            SetIndexDrawBegin(6,bb4_Period+1);SetIndexDrawBegin(7,bb4_Period+1);
            bb4_upBuffer[i]=iBands(Symbol(),0,bb4_Period,bb4_deviation,0,PRICE_CLOSE,MODE_UPPER,i);
            bb4_downBuffer[i]=iBands(Symbol(),0,bb4_Period,bb4_deviation,0,PRICE_CLOSE,MODE_LOWER,i);
           }
         else
           {
            SetIndexDrawBegin(6,bb4_Period+1);SetIndexDrawBegin(7,bb4_Period+1);
            bb4_upBuffer[i]=iBands(Symbol(),bb4_tf,bb4_Period,bb4_deviation,0,PRICE_CLOSE,MODE_UPPER,iBarShift(Symbol(),bb4_tf,time[i]));
            bb4_downBuffer[i]=iBands(Symbol(),bb4_tf,bb4_Period,bb4_deviation,0,PRICE_CLOSE,MODE_LOWER,iBarShift(Symbol(),bb4_tf,time[i]));
           }
         if(close[i]>bb4_upBuffer[i])alert(close[i],
            bb4_upBuffer[i],
            bb4_tf,
            bb4_up,
            bb4_doun,
            bb4_box,
            bb4_text_whrite,
            //            bb4_text_str,
            //            bb4_custom_box,
            bb4_custom_text,
            bb4_mail,
            bb4_push,
            bb4_audio,
            bb4_audio_up,
            bb4_audio_down,
            bb4_pause,
            bb4_sec
            );
         if(close[i]<bb4_downBuffer[i])alert(close[i],
            bb4_downBuffer[i],
            bb4_tf,
            bb4_up,
            bb4_doun,
            bb4_box,
            bb4_text_whrite,
            //            bb4_text_str,
            //            bb4_custom_box,
            bb4_custom_text,
            bb4_mail,
            bb4_push,
            bb4_audio,
            bb4_audio_up,
            bb4_audio_down,
            bb4_pause,
            bb4_sec
            );
        }
      if(bb5_tf_chart==Period())
        {
         if(bb5_tf==Period())
           {
            SetIndexDrawBegin(8,bb5_Period+1);SetIndexDrawBegin(9,bb5_Period+1);
            bb5_upBuffer[i]=iBands(Symbol(),0,bb5_Period,bb5_deviation,0,PRICE_CLOSE,MODE_UPPER,i);
            bb5_downBuffer[i]=iBands(Symbol(),0,bb5_Period,bb5_deviation,0,PRICE_CLOSE,MODE_LOWER,i);
           }
         else
           {
            SetIndexDrawBegin(8,bb5_Period+1);SetIndexDrawBegin(9,bb5_Period+1);
            bb5_upBuffer[i]=iBands(Symbol(),bb5_tf,bb5_Period,bb5_deviation,0,PRICE_CLOSE,MODE_UPPER,iBarShift(Symbol(),bb5_tf,time[i]));
            bb5_downBuffer[i]=iBands(Symbol(),bb5_tf,bb5_Period,bb5_deviation,0,PRICE_CLOSE,MODE_LOWER,iBarShift(Symbol(),bb5_tf,time[i]));
           }
         if(close[i]>bb5_upBuffer[i])alert(close[i],
            bb5_upBuffer[i],
            bb5_tf,
            bb5_up,
            bb5_doun,
            bb5_box,
            bb5_text_whrite,
            //            bb5_text_str,
            //            bb5_custom_box,
            bb5_custom_text,
            bb5_mail,
            bb5_push,
            bb5_audio,
            bb5_audio_up,
            bb5_audio_down,
            bb5_pause,
            bb5_sec
            );
         if(close[i]<bb5_downBuffer[i])alert(close[i],
            bb5_downBuffer[i],
            bb5_tf,
            bb5_up,
            bb5_doun,
            bb5_box,
            bb5_text_whrite,
            //            bb5_text_str,
            //            bb5_custom_box,
            bb5_custom_text,
            bb5_mail,
            bb5_push,
            bb5_audio,
            bb5_audio_up,
            bb5_audio_down,
            bb5_pause,
            bb5_sec
            );
        }
      if(bb6_tf_chart==Period())
        {
         if(bb6_tf==Period())
           {
            SetIndexDrawBegin(10,bb6_Period+1);SetIndexDrawBegin(11,bb6_Period+1);
            bb6_upBuffer[i]=iBands(Symbol(),0,bb6_Period,bb6_deviation,0,PRICE_CLOSE,MODE_UPPER,i);
            bb6_downBuffer[i]=iBands(Symbol(),0,bb6_Period,bb6_deviation,0,PRICE_CLOSE,MODE_LOWER,i);
           }
         else
           {
            SetIndexDrawBegin(10,bb6_Period+1);SetIndexDrawBegin(11,bb6_Period+1);
            bb6_upBuffer[i]=iBands(Symbol(),bb6_tf,bb6_Period,bb6_deviation,0,PRICE_CLOSE,MODE_UPPER,iBarShift(Symbol(),bb6_tf,time[i]));
            bb6_downBuffer[i]=iBands(Symbol(),bb6_tf,bb6_Period,bb6_deviation,0,PRICE_CLOSE,MODE_LOWER,iBarShift(Symbol(),bb6_tf,time[i]));
           }
         if(close[i]>bb6_upBuffer[i])alert(close[i],
            bb6_upBuffer[i],
            bb6_tf,
            bb6_up,
            bb6_doun,
            bb6_box,
            bb6_text_whrite,
            //            bb6_text_str,
            //            bb6_custom_box,
            bb6_custom_text,
            bb6_mail,
            bb6_push,
            bb6_audio,
            bb6_audio_up,
            bb6_audio_down,
            bb6_pause,
            bb6_sec
            );
         if(close[i]<bb6_downBuffer[i])alert(close[i],
            bb6_downBuffer[i],
            bb6_tf,
            bb6_up,
            bb6_doun,
            bb6_box,
            bb6_text_whrite,
            //            bb6_text_str,
            //            bb6_custom_box,
            bb6_custom_text,
            bb6_mail,
            bb6_push,
            bb6_audio,
            bb6_audio_up,
            bb6_audio_down,
            bb6_pause,
            bb6_sec
            );
        }
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void alert(double pr,
           double bb,
           int bb_tf,
           bool bb_up,
           bool bb_doun,
           bool bb_box,
           bool bb_text_whrite,
           //           string bb_text_str,
           //           bool bb_custom_box,
           string bb_custom_text,
           bool bb_mail,
           bool bb_push,
           bool bb_audio,
           string bb_audio_up,
           string bb_audio_down,
           bool bb_pause,
           int bb_sec
           )
  {
   int err=0;string bb_text_str="";bool al_tmp = false;
   if(bb_pause&&time_sec>TimeLocal()-bb_sec)return;
   time_sec = TimeLocal();
   if(tmp>1)return;
   tf(bb_tf);
   if(pr>bb&&bb_up)
     {
      if(bb_text_whrite)bb_text_str=StringSubstr(Symbol(),0,3)+"/"+StringSubstr(Symbol(),3,3)+" Broke ("+str+") BB UP";
      else bb_text_str=bb_custom_text;
      if(bb_audio)PlaySound(bb_audio_up);
      al_tmp = true;
     }

   if(pr<bb&&bb_doun)
     {
      if(bb_text_whrite)bb_text_str=StringSubstr(Symbol(),0,3)+"/"+StringSubstr(Symbol(),3,3)+" Broke ("+str+") BB DOWN";
      else bb_text_str=bb_custom_text;
      if(bb_audio)PlaySound(bb_audio_down);
      al_tmp = true;
     }
   if(al_tmp)
   {
   if(bb_box)Alert(bb_text_str);
   if(bb_mail)if(!SendMail("Message",bb_text_str))err=GetLastError();
   if(dt_push!=Time[0] && bb_text_str!="")
     {
      dt_push=Time[0];//Alert(msg);
      if(bb_push)
        {
         ResetLastError();err = 0;
         if(dt==TimeLocal() && count>2){Alert("Exceeded the limit for sending in sec. Push");return;}
         if(dt!=TimeLocal() && dt<=TimeLocal()-60 && count>10){Alert("Exceeded the limit for sending in Push min.");return;}
         if(!SendNotification(bb_text_str))err=GetLastError();
         //         else
         //            Alert("Push sent.");
         switch(err)
           {
            case 4250: Alert("Push - message not sent");break;
            case 4251: Alert("A Push message is not sent. Not correctly specified ID");break;
            case 4252: Alert("A Push message is not sent. Not specified ID");break;
            case 4253: Alert("A Push message is not sent. Exceeded the limit for sending.");break;
            default: break;
           }
        }
      dt=TimeLocal();count++;
      if(GlobalVariableSet(Global_DT,dt)==0) Alert("Write error global variable");
      if(GlobalVariableSet(Global_count,count)==0) Alert("Write error global variable");
     }
     }

  }
//-------------------------
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void tf(int per)
{
switch (per)
{
case 1:str = "M1";break;
case 5:str = "M5";break;
case 15:str = "M15";break;
case 30:str = "M30";break;
case 60:str = "H1";break;
case 240:str = "H4";break;
case 1440:str = "D1";break;
case 10080:str = "W1";break;
case 43200:str = "MN";break;
default:str = ""; break;
}}
//---------------------------------